/**************************************************************************/
/*                 Svga with Allegro source file                          */
/*																								  */
/* Heavily derived from code by Marat Fayzullin.								  */
/* Modified BERO for NES emulator													  */
/*																								  */
/*         Adapted by Zeograd (Olivier Jolly) for using Allegro			  */
/*																								  */
/**************************************************************************/

#ifdef ALLEGRO
#undef VGA

#include "svgaallg.h"
#include "lang.h"

/* Standard and Allegro includes */
BITMAP *XBuf;
// The screen buffer where we draw before blitting it on screen

extern char can_blit;
// can we draw or not ? (that's all the question)

// static int changepal;
// may be used later to make cleaner code (maybe faster)

// static int CPURunning;
// Is pce running (that was hard...)

BITMAP *EAGLE_buf=NULL;
// the buffer where we will put eagleized video

#if defined(DOUBLE_BUFFER)
UInt32 old_snd_pos = 0;
// the place where we've put snd to implement double buffer
#endif

UChar gamepad = 0;
// gamepad detected ?

char dump_snd = 0;
// Do we write sound to file

char synchro=0;
//  fond,  fond,  fond? (french joke ;)

extern unsigned message_delay;
// must we draw the message

int vwidth,vheight;
// size of visible part of the screen (I got troubles with allegro screen->? values!)

int blit_x,blit_y;
// where must we blit the screen buffer on screen

int screen_blit_x,screen_blit_y;
// where on the screen we must blit XBuf

BITMAP *MESSAGE_SPR=0;
// the bitmap containing the message to display (avoid textout each frame)

int vmode=0;
// video mode to use
// 0 -> first 256*240 then 256*256 and 320*200
// 1 -> 256*256 then 320*200
// 2 -> only try 320*200
// If you think others modes would be interesting, let me know

extern SChar silent;
// use sound?

// void OnBreak(int Arg){ set_gfx_mode(GFX_TEXT,0,0,0,0); CPURunning=0; }
// formely used to answer to ctrl-C

void SetPalette(void)
{
	int i;
   RGB r;
//        r.g=r.b=r.r=0xff;
  //      set_color(0,&r);

	for(i=0;i<255;i++)
           {
                r.r=(i&0x1c)<<1;
                r.g=(i&0xe0)>>2;
                r.b=(i&0x03)<<4;
	  	set_color(i,&r);
           }

}
// this function doesn't work too good, try not to load the intro piccy
// you will have some mess in colors. Play with it if you want, it mustn't
// be too hard to solve (I'm really lazy sometimes)

extern unsigned dwNewPos;
extern FILE * out_snd;

void PutImage(void)
{
 static int old=0;
 int dum;

 if (message_delay)
   draw_sprite(XBuf,MESSAGE_SPR,screen_blit_x+8,min(io.screen_h+screen_blit_y,vheight)-20);

// blit(XBuf,screen,74,0,blit_x,blit_y,XBUF_WIDTH+40,PCE_SCREEN_HEIGHT);
 if (use_eagle)
   {

     for (dum=0;dum<io.screen_h-1;dum++)
    {
      // Eagle-blit piccy to the screen 
      eagle (
             (unsigned long*)(XBuf->line[dum]+screen_blit_x)                  // First line of piccy  (320 pixels)
            ,(unsigned long*)(XBuf->line[dum+1]+screen_blit_x)              // 2nd line of piccy (320 pixels)
            ,io.screen_w
            ,EAGLE_buf->seg
	         ,(int)EAGLE_buf->line[dum*2] //  + ( ( (x   <<1) * piccy->w ) << 1)           // First eagled line = 320x2 = 640 pixels
            ,(int)EAGLE_buf->line[1+(dum*2)] // + (( ( (x+1)<<1) * piccy->w ) << 1)       // 2nd eagled line = 320x2 = 640 pixels
           );	 
    }
/*   {
    PALETTE pal;
    get_palette(pal);
    save_bitmap("test2.bmp",EAGLE_buf,pal);
   }*/

    blit(EAGLE_buf,screen,0,0,(320-io.screen_w),1,io.screen_w<<1,(io.screen_h-1)<<1/*480-2*/);
    }
 else

 blit(XBuf,screen,screen_blit_x,screen_blit_y,blit_x,blit_y,io.screen_w,io.screen_h);

 //fprintf(output_exl,"%u,\n",(unsigned )M.User-old);
 //old=(unsigned)M.User;
/* {
	unsigned	dum;
	unsigned tmp;
	for (dum=0;dum<dwNewPos;dum++)
    {
		tmp=(sbuf[0][dum]+sbuf[1][dum]+sbuf[2][dum]+sbuf[3][dum]+sbuf[4][dum]+sbuf[5][dum])/6;
		putc(tmp,output_exl);
    }
//   fwrite(sbuf[1],1,dwNewPos,output_exl);
 }*/
#ifndef PROFILING
 if (synchro)
	{
     asm ("begin_sync:
         call _pause
         movb _can_blit,%al
         testb %al,%al
         je begin_sync");
	  can_blit=0;
   }
#endif

  if (!silent)
	 {
		char ch;
      for (ch=0;ch<6;ch++ )
		 {
	      write_psg(ch);
//			for (dum=0;dum<dwNewPos;dum++)
	//			fprintf(stderr,"CH %d : %d\n",ch,sbuf[ch][dum]);
			//fprintf(stderr,"OUT : sbuf[ch] = %p\n",sbuf[ch]);
       }

      for (dum=0;dum<dwNewPos;dum++)
		  {
			//fprintf(stderr,"%3d %3d %3d %3d %3d %3d\n",sbuf[0][dum],sbuf[1][dum],sbuf[2][dum],sbuf[3][dum],sbuf[4][dum],sbuf[5][dum]);
			main_buf[dum]=(sbuf[0][dum]+sbuf[1][dum]+sbuf[2][dum]+sbuf[3][dum]+sbuf[4][dum]+sbuf[5][dum])>>2 ;
			}
			//lpWave->lpData[dum]=-0x60+(sbuf[0][dum]+sbuf[1][dum]+sbuf[2][dum]+sbuf[3][dum]+sbuf[4][dum]+sbuf[5][dum])>>1;
		if (dump_snd)
        fwrite(main_buf,1,dwNewPos,out_snd);
		  //fwrite(sbuf[5],1,dwNewPos,out_snd);
//		for (can_blit=0;can_blit<6 ;can_blit++ )
//			{
            //lpWave->lpData = main_buf;
/*			  if (next==0)
             {
				   long dum;
				   memcpy(lpWave->lpData,main_buf,dwNewPos);
					do
                 {
						 AGetVoicePosition(hVoice,&dum);
                   AUpdateAudio();
						 fprintf(stderr,"1 : %d / %d\n",dum,old);
                 }
               while (dum<old-10);

					AWriteAudioData(lpWave, 0L, lpWave->dwLength);
					ASetVoicePosition(hVoice,0);
					old=dwNewPos;
					next=dwNewPos;
             }
           else
             {
				   long dum;
				   memcpy(&lpWave->lpData[next],main_buf,dwNewPos);
					do
                 {
						 AGetVoicePosition(hVoice,&dum);
						 AUpdateAudio();
						 fprintf(stderr,"2 : %d / %d\n",dum,old);
                 }
               while (dum<old-10);
					lpWave->dwLoopEnd=next+dwNewPos+1;

					AWriteAudioData(lpWave, 0 ,lpWave->dwLength);
					ASetVoicePosition(hVoice,next);
					old=next+dwNewPos+1;
					next=0;
             }
  */


#if defined(SEAL_SOUND)

#if defined(DOUBLE_BUFFER)

		      memcpy(lpWave->lpData+old_snd_pos,main_buf,lpWave->dwLength-old_snd_pos);

            if (old_snd_pos)
              {

#ifndef FINAL_RELEASE
            fprintf(stderr,"set loop end to %d\n",old_snd_pos+dwNewPos);
#endif
				lpWave->dwLoopEnd = old_snd_pos+dwNewPos;
            // set the loop end to the end of the sample

		      //ASetVoicePosition(hVoice,0);
            AWriteAudioData(lpWave, 0L, lpWave->dwLength);

				{
				 long dum;
				 do
				  {
					AGetVoicePosition(hVoice,&dum);

#ifndef FINAL_RELEASE
					fprintf(stderr,"%d / %d\n",dum,old_snd_pos+dwNewPos);
#endif

					AUpdateAudio();
              }
             while (dum>old_snd_pos);
				 }

             old_snd_pos=0;
               }
            else
              {

#ifndef FINAL_RELEASE
                     fprintf(stderr,"i've not set loop end\n");
#endif
               old_snd_pos=dwNewPos;
               AWriteAudioData(lpWave, 0L, lpWave->dwLength);

  				{
				 long dum;
				 do
				  {
					AGetVoicePosition(hVoice,&dum);

#ifndef FINAL_RELEASE
					fprintf(stderr,"%d / %d\n",dum,old_snd_pos);
#endif

					AUpdateAudio();
              }
             while (dum<old_snd_pos);
				 }


               }

		      //memcpy(lpWave->lpData,main_buf,lpWave->dwLength);
				//memcpy(lpWave->lpData,sbuf[2],lpWave->dwLength);
				//lpWave->dwLoopEnd = dwNewPos;
            //AWriteAudioData(lpWave, 0L, lpWave->dwLength);

		      //ASetVoicePosition(hVoice,0);
				//old=dwNewPos;
  //       }

      AUpdateAudio();


#else /* not double buffer */
				{
				 long dum;
				 do
				  {
					AGetVoicePosition(hVoice,&dum);
#ifndef FINAL_RELEASE
					fprintf(stderr,"%d / %d\n",dum,old);
#endif
					AUpdateAudio();
              }
             while (dum<old-10);
				 }

		      memcpy(lpWave->lpData,main_buf,lpWave->dwLength);
				//memcpy(lpWave->lpData,sbuf[2],lpWave->dwLength);
				lpWave->dwLoopEnd = dwNewPos;
            AWriteAudioData(lpWave, 0L, lpWave->dwLength);

		      ASetVoicePosition(hVoice,0);
				old=dwNewPos;
  //       }

      AUpdateAudio();

#endif /* else double buffer */

#endif /* SEAL sound */
    }
  // it doesn't work too bad because this function is regulary called

}

/* TrashMachine - Uninitialise everything */
void TrashMachine(void)
{
 textout(screen,font,MESSAGE[language][shut_down],0,0,1);
 destroy_bitmap(XBuf);
 if (MESSAGE_SPR)
   destroy_bitmap(MESSAGE_SPR);

 if (EAGLE_buf)
   destroy_bitmap(EAGLE_buf);

  (*fade_out_proc[rand()%nb_fadeout])(0,0,vwidth,vheight);


 {
  UInt32 x;
  for (x=0;x<VRAMSIZE/32;x++)
	  destroy_bitmap(dirty_spr[x]);
  }


 set_gfx_mode(GFX_TEXT,0,0,0,0);

#if defined(SEAL_SOUND) || defined(ALLEG_SOUND)
 TrashSound();
#endif
 return ;
}


/* InitMachine - Starts up all the stuff */
int InitMachine(void)
{
 set_gfx_mode(GFX_TEXT,0,0,0,0);
 printf(MESSAGE[language][init_allegro]);

 printf(MESSAGE[language][translated_by]);

 if (!(XBuf=create_bitmap(XBUF_WIDTH+40,HEIGHT)))
  {
   printf(MESSAGE[language][failed_init]);
   return (0); 
  }

 printf(MESSAGE[language][clear_buffer]);
 clear(XBuf);

 if (!install_joystick(JOY_TYPE_AUTODETECT))
	{
	 printf(MESSAGE[language][joy_detected]);
	 gamepad=1;
	 }
 else
	{
	 printf(MESSAGE[language][joy_no_detected]);
	 gamepad=0;
	 }

 printf(MESSAGE[language][alloc_spr]);
 {
   UInt32 x;
   for (x=0;x<VRAMSIZE/32;x++)
		{
		 if (!(dirty_spr[x]=create_bitmap(16,16)))
			{
			  printf(MESSAGE[language][failed_init]);
			  return 0;
         }
        clear(dirty_spr[x]);
		 }
  }

#if defined(SEAL_SOUND) || defined(ALLEG_SOUND)
 printf(MESSAGE[language][init_sound]);
 InitSound();
#endif
 
  if (use_eagle)
   {
    printf(MESSAGE[language][eagle_asked]);
    if (!set_gfx_mode(GFX_AUTODETECT,640,480,0,0))
            {
             vwidth=640;
             vheight=480;
             blit_x=(320-256)/2;
             blit_y=(240-216)/2;
				 screen_blit_x=(WIDTH-io.screen_h)/2;
				 screen_blit_y=(HEIGHT-io.screen_w)/2;
             SetPalette();

             EAGLE_buf=create_bitmap(640,480);

             }
    else
      printf(MESSAGE[language][eagle_mode_not_init]);
    }
  else
 if (!init_normal_mode())
	{
	 printf(MESSAGE[language][cant_set_gmode]);
	 return 0;
	 }
/*
            if ((vmode==0) && (!set_hugo_mode(256,240,256,240)));
            else
              if ((vmode<=1) && (!set_hugo_mode(256,256,256,240)));
            else
              if ((vmode<=2) && (!set_hugo_mode(320,200,256,240)));
            else
            {
             printf(MESSAGE[language][cant_set_gmode]);
             return 0;
             }*/
 // textout(screen,font,"OK\n Allocating colors...\n",0,0,1);


 text_mode(-1);
 install_keyboard();
 clear(screen);
 return 1;
}

unsigned short savepict()
  {
          BITMAP *bmp;
          PALETTE pal;
          char* final="PICT0000.PCX";
          short unsigned tmp=0;

          while ((tmp!=0xFFFF) && (exists(final)))
              sprintf(final,"PICT%04X.PCX",++tmp);
          if (tmp==0xFFFF)
            return tmp;

          get_palette(pal);
          if (use_eagle)
          bmp = create_sub_bitmap(screen, (320-io.screen_w), 1 ,
											 io.screen_w*2,
											 io.screen_h*2);
          else
          bmp = create_sub_bitmap(screen, blit_x, blit_y,
											 io.screen_w,
											 io.screen_h);
/*          bmp = create_sub_bitmap(XBuf, 0, 0, XBUF_WIDTH
											 min(screen->w,256),
											 min(screen->h-blit_y,PCE_SCREEN_HEIGHT));*/
          save_bitmap(final, bmp, pal);
//          save_bitmap(final, XBuf, pal);
          destroy_bitmap(bmp);
#ifndef FINAL_RELEASE
          fprintf(stderr,"picture saved %s\n",final);
#endif
          return tmp;

   }
// save a picture named PICTXXXX.PCX where XXXX is good so that it doesn't
// erase any file


/*****************************************************************************

    Function:  set_message

    Description: create the sprite to display on screen for messages
    Parameters:char* mess, a pointer to the message to display
    Return:nothing

*****************************************************************************/
void set_message(char* mess)
{
 if (MESSAGE_SPR)
   destroy_bitmap(MESSAGE_SPR);
 MESSAGE_SPR=create_bitmap(text_length(font,mess)+1,text_height(font)+1);
 clear(MESSAGE_SPR);
 textout(MESSAGE_SPR,font,mess,1,1,3);
 textout(MESSAGE_SPR,font,mess,0,0,255);
 return;
 }


/*****************************************************************************

    Function:  set_hugo_mode

    Description: change the video mode
    Parameters: width, height : minimum size of screen required
	             pce_width,pce_height : size of the screen of the PCE
    Return: 0 on success
	         1 on error

*****************************************************************************/
int set_hugo_mode(int width,int height,int pce_width,int pce_height)
{

 if (!set_gfx_mode(GFX_AUTODETECT,width,height,0,0))
            {
             vwidth=width;
             vheight=height;
				 blit_x=(width-pce_width)/2;
             blit_y=(height-pce_height)/2;
				 screen_blit_x=(WIDTH-io.screen_w)/2;
				 screen_blit_y=(HEIGHT-io.screen_h)/2;
             SetPalette();
				 return 0;
             }
 return 1;
 }

/*****************************************************************************

    Function:  init_normal_mode

    Description: initialize the classic 256*216 video mode
    Parameters: none
    Return: 0 on error
	         1 on success

*****************************************************************************/
int init_normal_mode()
{
  if ((vmode==0) && (!set_hugo_mode(256,240,256,240)));
   else
  if ((vmode<=1) && (!set_hugo_mode(256,256,256,240)));
   else
  if ((vmode<=2) && (!set_hugo_mode(320,200,256,240)));
   else
	  return 0;

 return 1;
 }


#else // ALLEGRO section ended
  #error include "svga.h" not this one!!!!!!
#endif
